<?php

require_once(__DIR__.'/_legacy.php');

class ModuleFrontControllerCore extends FrontController
{
    /** @var Module */
    public $module;
    
    public $errors = array();
    
    protected static $smarty, $cookie, $link, $cart;
    
    public $iso;
    
    public $orderBy;
    public $orderWay;
    public $p;
    public $n;
    
    public $auth = false;
    public $guestAllowed = false;
    public $authRedirection = false;
    public $ssl = false;
    
    protected $restrictedCountry = false;
    protected $maintenance = false;
    
    public $display_column_left = true;
    public $display_column_right = true;
    
    public static $initialized = false;
    
    protected static $currentCustomerGroups;
    
    public $overide_folder = '';
    
    public $nb_items_per_page;
    
    public $js_files = array();
    public $css_files = array();
    
    public function __construct()
    {
        
        parent::__construct();
        $this->module = Module::getInstanceByName(Tools::getValue('module'));
        if (empty($this->module->active)) {
            Tools::redirect('index.php');
        }
        $this->context = Context::getContext();
        $this->cookie = $this->context->cookie;
        $this->cart = $this->context->cart;
        $this->smarty = $this->context->smarty;
        $this->link = $this->context->link;
        $this->context->controller = $this;
        $this->ajax = Tools::getValue('ajax') || Tools::isSubmit('ajax');
        
        global $link;
        $link = $this->link = $this->context->link = new LinkLegacy();
        $this->context->smarty->assign(array(
           'link' => $this->context->link,          
        ));
        $this->page_name = 'module-'.$this->module->name.'-'.'';
    }
    
    public function initContent() {}
    
    public function init()
    {
        parent::init();
        $this->setMedia();
        global $css_files, $js_files;
        $css_files = array_merge($css_files, $this->css_files);
        $js_files = array_merge($js_files,$this->js_files);
    }
    public function run()
    {
        $this->init();
        $this->initContent();
        $this->preProcess();
        $this->displayHeader();
        $this->process();
        $this->displayContent();
        $this->displayFooter();
    }

    public static function toCamelCase($str, $capitalise_first_char = false)
    {
        $str = strtolower($str);
        if ($capitalise_first_char)
            $str = ucfirst($str);
            return preg_replace_callback('/_+([a-z])/', create_function('$c', 'return strtoupper($c[1]);'), $str);
    }
    public function addJS($js_uri)
    {
        if (is_array($js_uri))
            foreach ($js_uri as $js_file)
            {
                $js_path = Media::getJSPath($js_file);
                if ($js_path && !in_array($js_path, $this->js_files))
                    $this->js_files[] = $js_path;
            }
        else
        {
            $js_path = Media::getJSPath($js_uri);
            if ($js_path)
                $this->js_files[] = $js_path;
        }
    }
    public function addCSS($css_uri, $css_media_type = 'all')
    {
        if (is_array($css_uri))
            foreach ($css_uri as $css_file => $media)
            {
                if (is_string($css_file) && strlen($css_file) > 1)
                {
                    $css_path = Media::getCSSPath($css_file, $media);
                    if ($css_path && !in_array($css_path, $this->css_files))
                        $this->css_files = array_merge($this->css_files, $css_path);
                }
                else
                {
                    $css_path = Media::getCSSPath($media, $css_media_type);
                    if ($css_path && !in_array($css_path, $this->css_files))
                        $this->css_files = array_merge($this->css_files, $css_path);
                }
            }
        else if (is_string($css_uri) && strlen($css_uri) > 1)
        {
            $css_path = Media::getCSSPath($css_uri, $css_media_type);
            if ($css_path)
                $this->css_files = array_merge($this->css_files, $css_path);
        }
    }
    public function addJqueryUI($component, $theme = 'base', $check_dependencies = true)
    {
        $ui_path = array();
        if (!is_array($component))
            $component = array($component);
    
            foreach ($component as $ui)
            {
                $ui_path = Media::getJqueryUIPath($ui, $theme, $check_dependencies);
                $this->addCSS($ui_path['css']);
                $this->addJS($ui_path['js']);
            }
    }
    
    public function addJqueryPlugin($name, $folder = null)
    {
        $plugin_path = array();
        if (is_array($name))
        {
            foreach ($name as $plugin)
            {
                $plugin_path = Media::getJqueryPluginPath($plugin, $folder);
                if(!empty($plugin_path['js']))
                    $this->addJS($plugin_path['js']);
                    if(!empty($plugin_path['css']))
                        $this->addCSS($plugin_path['css']);
            }
        }
        else
        {
            $plugin_path = Media::getJqueryPluginPath($name, $folder);
    
            if(!empty($plugin_path['css']))
                $this->addCSS($plugin_path['css']);
                if(!empty($plugin_path['js']))
                    $this->addJS($plugin_path['js']);
        }
    }
    public function setTemplate($template) { $this->template = $template; }
    
    public function createTemplate($tpl_name)	{	return $this->context->smarty->createTemplate($this->getTemplatePath().$this->override_folder.$tpl_name, $this->context->smarty);	}
    protected function smartyOutputContent($content)
    {
        $this->context->cookie->write();
        $this->context->smarty->display($content);
    }
    public function getTemplatePath()
    {
        return _PS_MODULE_DIR_.$this->module->name.'/views/templates/front/';
    }
    
    public function displayContent()
    {
        $this->context->smarty->assign('errors', $this->errors);
        parent::displayContent();
        $this->context->smarty->display($this->getTemplatePath().$this->override_folder.$this->template);
    }
    
    
}